using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Configuration;
using MediaPortal.GUI.Library;
using MediaPortal.Configuration;
using MediaPortal.Dialogs;

namespace Traffic
{
  public class TrafficGUI : GUIWindow, ISetupForm
  {

    #region ISetupForm Members

    public string PluginName()
    {
      return "Traffic";
    }

    // Returns the description of the plugin is shown in the plugin menu
    public string Description()
    {
      return "Shows ANWB Traffic Information";
    }

    // Returns the author of the plugin which is shown in the plugin menu
    public string Author()
    {
      return "achappey";
    }

    // show the setup dialog
    public void ShowPlugin()
    {
      MessageBox.Show("Just an example");
    }

    // Indicates whether plugin can be enabled/disabled
    public bool CanEnable()
    {
      return true;
    }

    // Enter the id number here again
    public int GetWindowId()
    {
      return 9662;
    }
    // Indicates if plugin is enabled by default;
    public bool DefaultEnabled()
    {
      return true;
    }

    // indicates if a plugin has it's own setup screen
    public bool HasSetup()
    {
      return false;
    }

    /// <summary>
    /// If the plugin should have it's own button on the main menu of MediaPortal then it
    /// should return true to this method, otherwise if it should not be on home
    /// it should return false
    /// </summary>
    /// <param name="strButtonText">text the button should have</param>
    /// <param name="strButtonImage">image for the button, or empty for default</param>
    /// <param name="strButtonImageFocus">image for the button, or empty for default</param>
    /// <param name="strPictureImage">subpicture for the button or empty for none</param>
    /// <returns>true : plugin needs it's own button on home
    /// false : plugin does not need it's own button on home</returns>

    public bool GetHome(out string strButtonText, out string strButtonImage, out string strButtonImageFocus, out string strPictureImage)
    {
      strButtonText = PluginName();
      strButtonImage = String.Empty;
      strButtonImageFocus = String.Empty;
      strPictureImage = String.Empty;
      return true;
    }

    #endregion
  }
}
