using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Configuration;
using MediaPortal.GUI.Library;
using MediaPortal.Configuration;

namespace Traffic
{
  class TrafficReader
  {
    private Region currentRegion = null;

    HttpWebRequest httprequest;
    HttpWebResponse httpresponse;

    Uri requestUri;
    StreamReader bodyreader;
    Stream responsestream;
    string HTML = string.Empty;
    int StartIndex = 0;
    int EndIndex = 0;

    public enum Source
    {
      Netherlands,
      USA_LA,
      USA_SanDiego
    }

    private void ReadHTML()
    {
      try
      {
        requestUri = new Uri(currentRegion.URL);

        httprequest = (HttpWebRequest)WebRequest.Create(requestUri);
        httprequest.UserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.2; .NET CLR 1.0.3705;)";
        httpresponse = (HttpWebResponse)httprequest.GetResponse();
        responsestream = httpresponse.GetResponseStream();

        if (responsestream != null)
        {
          bodyreader = new StreamReader(responsestream);

          HTML = bodyreader.ReadToEnd();

          bodyreader.Close();

        }

        httpresponse.Close();

        httpresponse = null;
        httprequest = null;
      }
      catch (Exception e)
      {
        Log.Info("Traffic: " + e.ToString());
      }
      Log.Info("Traffic: " + HTML);

    }

    private void ReadSanDiego()
    {
      if (HTML.IndexOf("</TD></TR><TR><TD class='menuitem'>") > 0)
      {
        while (HTML.IndexOf("</TD></TR><TR><TD class='menuitem'>") > 0)
        {
          Jam j = new Jam();

          HTML = HTML.Remove(0, HTML.IndexOf("</TD></TR><TR><TD class='menuitem'>") + 35);

          //        StartIndex = HTML.IndexOf("<TD class=head>SPEED<BR></TD></TR><TR><TD class='menuitem'>") + 59;
          EndIndex = HTML.IndexOf("<BR></TD>");
          j.Road = HTML.Substring(0, EndIndex);

          HTML = HTML.Remove(0, HTML.IndexOf("<BR></TD>") + 10);
          StartIndex = HTML.IndexOf(">") + 1;
          EndIndex = HTML.IndexOf("</TD></TR>");
          j.Length = HTML.Substring(StartIndex, EndIndex - StartIndex);

          Log.Info("Traffic: " + j.Length);

          currentRegion.Jams.Add(j);
        }

      }



    }

    private void ReadLACity()
    {
      if (HTML.IndexOf("images['refreshPic'].src = '") > 0)
      {
        StartIndex = HTML.IndexOf("images['refreshPic'].src = '") + 28;
        EndIndex = HTML.IndexOf("?'+Math.random();");
        currentRegion.BasisLayerLink = HTML.Substring(StartIndex, EndIndex - StartIndex);
        Log.Info("Traffic: " + currentRegion.BasisLayerLink);
      }

      HTML = HTML.Remove(0, HTML.IndexOf("<!-- Table displaying road closures -->") + 60);

      if ((HTML.IndexOf("<!--") < HTML.IndexOf("No known closures at this time.")))
      {
        Roadwork r = new Roadwork();

        HTML = HTML.Remove(0, HTML.IndexOf("<!-- END CLOSURE TEMPLATE -->"));
        StartIndex = HTML.IndexOf("<td class=\"map_table_td\" width=\"410\">") + 38;
        EndIndex = HTML.IndexOf("<td class=\"map_table_td\" width=\"150\" align=\"left\">") - 7;

        r.Road = HTML.Substring(StartIndex, EndIndex - StartIndex);
        currentRegion.Roadworks.Add(r);
  //      Log.Info("Traffic: " + Status);
      }

    }

    private void ReadANWB()
    {

      if (HTML.IndexOf("Verkeerssituatie ") > 0)
      {
        HTML = HTML.Remove(0, HTML.IndexOf("Verkeerssituatie ") - 3);
        StartIndex = HTML.IndexOf("Verkeerssituatie ") + 17;

        EndIndex = HTML.IndexOf("<BR>");
        currentRegion.Status = HTML.Substring(StartIndex, EndIndex - StartIndex);
//        Log.Info("Traffic: " + Status);
      }
      else if ((HTML.IndexOf("verkeerssituatie ") > 0))
      {
        HTML = HTML.Remove(0, HTML.IndexOf("verkeerssituatie ") - 3);

        StartIndex = HTML.IndexOf("verkeerssituatie ") + 17;

        EndIndex = HTML.IndexOf("</td>");
        currentRegion.Status = HTML.Substring(StartIndex, EndIndex - StartIndex);
  //      Log.Info("Traffic: " + Status);
      }

      if (HTML.IndexOf("vspace=\"0\" hspace=\"0\" border=\"0\"><SPAN class=\"contentKop\">") > 0)
      {
        StartIndex = HTML.IndexOf("vspace=\"0\" hspace=\"0\" border=\"0\"><SPAN class=\"contentKop\">") + 59;
        EndIndex = HTML.IndexOf(" meldingen in Nederland");
        currentRegion.Reports = HTML.Substring(StartIndex, EndIndex - StartIndex);
        //Log.Info("Traffic: " + Reports);
        HTML = HTML.Remove(0, HTML.IndexOf(" meldingen in Nederland") + 30);
      }


      if (HTML.IndexOf("Totale lengte ") > 0)
      {
        StartIndex = HTML.IndexOf("Totale lengte ") + 14;
        EndIndex = HTML.IndexOf("</SPAN>") - 1;
        currentRegion.TotalLength = HTML.Substring(StartIndex, EndIndex - StartIndex);
        //Log.Info("Traffic: " + TotalLength);
      }


      StartIndex = HTML.IndexOf("id=\"basis_layer_i\" name=\"basis_layer_i\" src=") + 45;
      EndIndex = HTML.IndexOf("\" usemap=\"#Map\"></div>");
      currentRegion.BasisLayerLink = HTML.Substring(StartIndex, EndIndex - StartIndex);
      //Log.Info("Traffic: " + BasisLayerLink);

      HTML = HTML.Remove(0, HTML.IndexOf("\" usemap=\"#Map\"></div>") + 22);

      StartIndex = HTML.IndexOf("id=\"jam_layer2_i\" name=\"jam_layer2_i\" src=\"") + 43;
      EndIndex = HTML.IndexOf("\" usemap=\"#Map\"></div>");
      currentRegion.JamLayerLink1 = HTML.Substring(StartIndex, EndIndex - StartIndex);
      //Log.Info("Traffic: " + JamLayerLink1);

      HTML = HTML.Remove(0, HTML.IndexOf("\" usemap=\"#Map\"></div>") + 22);

      if (HTML.IndexOf("id=\"jam_layer_i\" name=\"jam_layer_i\" src=\"") > 0)
      {
        StartIndex = HTML.IndexOf("id=\"jam_layer_i\" name=\"jam_layer_i\" src=\"") + 41;
        EndIndex = HTML.IndexOf("\" usemap=\"#Map\"></div>");
        currentRegion.JamLayerLink2 = HTML.Substring(StartIndex, EndIndex - StartIndex);
       // Log.Info("Traffic: " + JamLayerLink2);
      }


      if (HTML.IndexOf("var cam_layer_image='") > 0)
      {
        StartIndex = HTML.IndexOf("var cam_layer_image='") + 21;
        EndIndex = HTML.IndexOf("var cam_layer_image='") + 68;
        currentRegion.CamLayerLink = HTML.Substring(StartIndex, EndIndex - StartIndex);
        //Log.Info("Traffic: " + CamLayerLink);
      }

      if (HTML.IndexOf("var roadwork_layer_image='") > 0)
      {
        StartIndex = HTML.IndexOf("var roadwork_layer_image='") + 26;
        EndIndex = HTML.IndexOf("var roadwork_layer_image='") + 73;
        currentRegion.RoadworkLayerLink = HTML.Substring(StartIndex, EndIndex - StartIndex);
        //Log.Info("Traffic: " + RoadworkLayerLink);
      }

      if (HTML.IndexOf("var speedcamera_layer_image='") > 0)
      {
        StartIndex = HTML.IndexOf("var speedcamera_layer_image='") + 29;
        EndIndex = HTML.IndexOf("var speedcamera_layer_image='") + 76;
        currentRegion.SpeedCameraLayerLink = HTML.Substring(StartIndex, EndIndex - StartIndex);
        //Log.Info("Traffic: " + SpeedCameraLayerLink);
      }

      HTML = HTML.Remove(0, HTML.IndexOf("var weather_layer_image=") - 2);
      StartIndex = HTML.IndexOf("var weather_layer_image='") + 25;
      EndIndex = HTML.IndexOf(".gif") + 4;
      currentRegion.WeatherLayerLink = HTML.Substring(StartIndex, EndIndex - StartIndex);
      //Log.Info("Traffic: " + WeatherLayerLink);


      if (HTML.IndexOf("Geen filemeldingen.") < 0)
      {

        while (HTML.IndexOf("<td class=\"contentTekst\" align=\"left\" width=\"600\" valign=\"top\">") < HTML.IndexOf("Vertragende werkzaamheden") &&
              HTML.IndexOf("<td class=\"contentTekst\" align=\"left\" width=\"600\" valign=\"top\">") < HTML.IndexOf("&nbsp;Flitsers (mobiel)"))
        {
          HTML = HTML.Remove(0, HTML.IndexOf("<td class=\"contentTekst\" align=\"left\" width=\"600\" valign=\"top\">") - 2);

          Jam j = new Jam();

          StartIndex = HTML.IndexOf("<td class=\"contentTekst\" align=\"left\" width=\"600\" valign=\"top\">") + 67;
          EndIndex = HTML.IndexOf("</b>");
          j.Road = HTML.Substring(StartIndex, EndIndex - StartIndex);
          Log.Info("Traffic: " + j.Road);

          StartIndex = HTML.IndexOf("</b>") + 5;
          EndIndex = HTML.IndexOf("</td>") - 1;
          j.Description = HTML.Substring(StartIndex, EndIndex - StartIndex);
          Log.Info("Traffic: " + j.Description);

          HTML = HTML.Remove(0, HTML.IndexOf("<nobr>") - 1);

          StartIndex = HTML.IndexOf("<b>") + 3;
          EndIndex = HTML.IndexOf("</b>");
          if (EndIndex > StartIndex)
          {
            j.Length = HTML.Substring(StartIndex, EndIndex - StartIndex);
            Log.Info("Traffic: " + j.Length);
          }

          HTML = HTML.Remove(0, HTML.IndexOf("<nobr>") - 1);

          currentRegion.Jams.Add(j);
        }
      }

      if (HTML.IndexOf("Vertragende werkzaamheden") < HTML.IndexOf("&nbsp;Flitsers (mobiel)"))
      {
        while (HTML.IndexOf("<td class=\"contentTekst\" align=\"left\" width=\"600\" valign=\"top\">") < HTML.IndexOf("Flitsers (mobiel)"))
        {
          HTML = HTML.Remove(0, HTML.IndexOf("<td class=\"contentTekst\" align=\"left\" width=\"600\" valign=\"top\">") - 2);

          Roadwork r = new Roadwork();

          StartIndex = HTML.IndexOf("<td class=\"contentTekst\" align=\"left\" width=\"600\" valign=\"top\">") + 67;
          EndIndex = HTML.IndexOf("</b>");
          r.Road = HTML.Substring(StartIndex, EndIndex - StartIndex);
          Log.Info("Traffic: " + r.Road);

          StartIndex = HTML.IndexOf("</b>") + 5;
          EndIndex = HTML.IndexOf("</td>") - 1;
          r.Description = HTML.Substring(StartIndex, EndIndex - StartIndex);
          Log.Info("Traffic: " + r.Description);

          HTML = HTML.Remove(0, HTML.IndexOf("<nobr>") - 1);

          currentRegion.Roadworks.Add(r);

        }

      }


      if (HTML.IndexOf("Geen flitsmeldingen.") < 0)
      {
        while (HTML.IndexOf("<td class=\"contentTekst\" align=\"left\" width=\"600\" valign=\"top\">") < HTML.IndexOf("&nbsp;Alle meldingen op wegnummer"))
        {
          HTML = HTML.Remove(0, HTML.IndexOf("<td class=\"contentTekst\" align=\"left\" width=\"600\" valign=\"top\">") - 2);

          SpeedCam s = new SpeedCam();

          StartIndex = HTML.IndexOf("<td class=\"contentTekst\" align=\"left\" width=\"600\" valign=\"top\">") + 67;
          EndIndex = HTML.IndexOf("</b>");
          s.Road = HTML.Substring(StartIndex, EndIndex - StartIndex);
          Log.Info("Traffic: " + s.Road);

          StartIndex = HTML.IndexOf("</b>") + 5;
          EndIndex = HTML.IndexOf("</td>") - 1;
          s.Description = HTML.Substring(StartIndex, EndIndex - StartIndex);
          Log.Info("Traffic: " + s.Description);

          HTML = HTML.Remove(0, HTML.IndexOf("<nobr>") - 1);

          currentRegion.Speedcams.Add(s);

        }

      }

    }

    public Region ReadTraffic(Region r, Source s)
    {
      currentRegion = r;

      ReadHTML();

      if (s == Source.Netherlands)
      {
        ReadANWB();
      }
      else if (s == Source.USA_LA)
      {
        ReadLACity();
      }
      else if (s == Source.USA_SanDiego)
      {
        ReadSanDiego();
      }

      return currentRegion;
    }

    public TrafficReader()
    {

    }

  }
}
